/* calcLinkShape.cc */
/* $Lastupdate: Fri Nov 14 11:42:58 1997 $ */

/*

[ץ̾]

calcLinkShape.cc -- plain format V.1,2 ޤ sub-network format V.2 б --
                   ^^^^^^^^^^^^^^^^^^^^      ^^^^^^^^^^^^^^^^^^^^^^^^

[򤹤ץफ]

calcLinkShape.cc ϡplain format V.1,2 ޤ sub-network format V.2 
ƥ󥯤Ĺȸۤ׻ץǤ

[Ȥ]

(1) ʤǵư :

% calcLinkShape
# plain (or sub-network) format file (V.1,2) : daidogawa.pf2.data
# link shape file : daidogawa.shape.data
# sum length file : sumLength.dat
# default gradient : 0.001

(2) Ĥǵư :

% calcLinkShape daidogawa.pf2.data daidogawa.shape.data sumLength.dat 0.001

  o "daidogawa.pf2.data" ϡplain format V.2 ǡåȤǤ
  o "daidogawa.shape.data" ϡƥ󥯤Ĺȸۤ񤭹
    եǤ
  o "sumLength.dat" ϡƥ󥯤Ĺ¤񤭹
    եǤ
  o üɸͤ¬ΤȤϡ󥯤θۤ׻Ǥޤ󡣤
    Ȥϡ桼ꤷǥեȤθͤ򤽤Υ󥯤θ
    ȤޤǤ "0.001" ȤƤޤ

[ϥեΥեޥå]

plain format V.1 or V.2 (plain format) 
뤤 sub-network format V.2 (sub-network format)

[ϥեΥեޥå]

ϥեΥեޥåȤˤäƽϥեΥեޥåȤϰۤʤ롣

   ----------------------------------------------
   1. ƥ󥯤Ĺȸۤ񤭹ϥե
   ----------------------------------------------

      (1) ϥե뤬 plain format ξ硣

       @begin{daidogawa.shape.data} -----------------------------------
       # ޳ֹ (x, y), ƻʬֹ, ƻʬĹ, ƻʬ
       1 1 1 2072.300163 0.001000
       1 1 2 2627.658941 0.001000
       1 1 3 6074.187659 0.001000
       1 1 4 3475.392348 0.001000
       1 1 5 8659.349345 0.001000
       1 1 6 4727.656322 0.001000
       ...(ʲ³)
       @end{daidogawa.shape.data} -------------------------------------

      (2) ϥե뤬 sub-network format ξ硣

       @begin{chaophraya.shape.data} -----------------------------------
       # ޳ֹ (x, y), ֹ, ƻʬֹ, ƻʬĹ, ƻʬ
                         ^^^^^^^^^
       1 1 1 1 2072.300163 0.001000
       1 1 1 2 2627.658941 0.001000
       1 1 1 3 6074.187659 0.001000
       1 1 1 4 3475.392348 0.001000
       1 1 1 5 8659.349345 0.001000
       1 1 1 6 4727.656322 0.001000
       ...(ʲ³)
       @end{chaophraya.shape.data} -------------------------------------

   ----------------------------------------------
   2. ƥ󥯤Ĺ¤񤭹ϥե
   ----------------------------------------------

       (1) ϥե뤬 plain format ξ硣

        ---------------------
        # ޳ֹ (x, y), ƻĹ

        1 1 18345.972947
        ---------ޤ------------

       (2) ϥե뤬 sub-network format ξ硣

        ------------------------------
        # ޳ֹ (x, y), ֹ, ƻĹ
                   ^^^^^^^^
        1 1 1 18345.972947
            ^
        ---------ޤ---------------------

[ѥ]

% make

*/

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <math.h>

#include "dfopen.h"
#include "khboolean.h"

class Segment
{
  int gx;					// åֹ x
  int gy;					// åֹ y
  int sysNo;                                    // ֹ
  int snum;					// ƻʬֹ
  
  double len;					// Ĺ
  double grd;					// 
  
public:
  void Record(int ix, int iy, int numRsys, int num, double l, double g)
    { gx = ix; gy = iy; sysNo = numRsys; snum = num; len = l; grd = g; }
  
  void Print(FILE* fp)
    {
      if (sysNo == 0) {
	fprintf(fp, "%d %d %d %f %f\n", gx, gy, snum, len, grd);
      }
      else {
	fprintf(fp, "%d %d %d %d %f %f\n", gx, gy, sysNo, snum, len, grd);
      }
    }
};

int main(int argc, char** argv)
{
  // οΥå
  assert(argc == 1 || argc == 5);
  
  // ǡե̾ӥǥեȤθͤ
  char in[256], out[256], sum[256]; double GRD;
  if (argc == 1) {
    printf("# plain format file (V.1,2) : ");
    scanf("%s", in);
    printf("# output file : ");
    scanf("%s", out);
    printf("# sum length file : ");
    scanf("%s", sum);
    printf("# default gradient : ");
    scanf("%lf", &GRD);
  }
  else {
    sscanf(argv[1], "%s", in);
    sscanf(argv[2], "%s", out);
    sscanf(argv[3], "%s", sum);
    sscanf(argv[4], "%lf", &GRD);
  }
  
  FILE* fin;
  assert((fin = dataFileOpen(in)) != NULL);
  
  char buf[256];
  Segment* seg;
  int rsysNo = 0;              // sub-network format ξΤ߻Ȥ
                               // plain format ξ硢0 ˤƤ
  int numSegment;

  while (fgets(buf, 256, fin) != NULL) {

    // rsysNo 
    if (strncmp(buf, "[Sub-network Number]",15) == 0) {
      fgets(buf, 256, fin);
      sscanf(buf, "%d", &rsysNo);
      assert(rsysNo > 0);
    }

    // [Data] ˤʤä break
    if (strncmp(buf, "[Data]",6) == 0) break;
    
    // numSegment 
    if (strncmp(buf, "[Number of River Segments]",22) == 0) {
      fgets(buf, 256, fin);
      sscanf(buf, "%d", &numSegment);
	  if(numSegment <= 0) exit(1);
      //assert(numSegment > 0);
      
      //  seg 
      assert((seg = new Segment[numSegment]) != NULL);
    }
  }
  
  int ix, iy;					// åɥܥåֹ
  int pnum;					// üֹ
  int snum;					// ƻʬֹ
  int pos;					// ־
  double x, y, z;				// ֺɸ
  double w;					// ƻ
  
  double len, grd;
  double lenSum = 0.;                           // οƻĹ
  double sx, sy, sz;
  
  KhBoolean inside = NO; // YES : ƻʬ
                         // NO  : ƻʬФ
  
  KhBoolean reverse = NO;		// ǡήäƤ뤫
                                        // ɤ
  
  int segCount = 0;
  
  while (fgets(buf, 256, fin) != NULL && segCount <= numSegment) {
    assert(sscanf(buf, "%d %d %d %d %d %lf %lf %lf %lf",
		  &ix, &iy, &pnum, &snum, &pos, 
		  &x, &y, &z, &w) == 9);
    
    // ʲƻʬä
    if (inside == NO && pos >= 0) {
      inside = YES;
      reverse = (pnum < 0) ? YES : NO;
      segCount++;
      len = grd = 0.;
      sx = x; sy = y; sz = z;
    }
    // Ĥβƻʬä
    else if (inside == YES && pos >= 0) {
      inside = NO;
      len += sqrt((x - sx) * (x - sx) + (y - sy) * (y - sy));
      lenSum += len;
      if (sz == 0. || z == 0.) grd = GRD;
      else {
		  if(len == 0.) grd = GRD;
		  else{
			  grd = (sz - z) / len;
			  grd = (reverse == YES) ? -grd : grd;
		  }
	// ۤˤʤ褦ʲƻʬڤĹ 0 
	// ƻʬˤĤƤϥǥեͤѤ롣
		  if(grd <= 0.) grd = GRD;
      }
      seg[segCount - 1].Record(ix, iy, rsysNo, snum, len, grd);
    }
    // ƻʬ
    else {
      len += sqrt((x - sx) * (x - sx) + (y - sy) * (y - sy));
      sx = x; sy = y;
    }
  }
  
  fclose(fin);
  assert(segCount == numSegment);
  
  // 
  FILE* fout;
  assert((fout = fopen(out, "a")) != NULL);
  
  // إåν
  fprintf(fout, "\n# %s\n", out);
  fprintf(fout, "# produced by %s from %s\n\n", argv[0], in);
  
  // ׻̤ν
  int i;
  for (i = 0; i < numSegment; i++) seg[i].Print(fout);
  fclose(fout);
  delete [] seg;

  // ƻʬĹ
  FILE* fsum;
  assert((fsum = fopen(sum, "a")) != NULL);
  if (rsysNo == 0) {
    // plain format
    fprintf(fsum, "%d %d %f\n", ix, iy, lenSum);
  }
  else {
    // sub-network format
    fprintf(fsum, "%d %d %d %f\n", ix, iy, rsysNo, lenSum);
  }
  fclose(fsum);

  return 0;
}
