/*
-----------------------------------
$B%W%m%0%i%`L>(B:ll2utm-dataset.cc
$BL\E*(B:$B0^7PEY$G=q$+$l$?%G!<%?%;%C%H(B(plain format V2)$B$r(B
     UTM$B:BI8$G=q$+$l$?$b$N$KJQ49$9$k!#(B
-----------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ll2utm.h"

int main(int argc, char** argv)
{
  char inputdata[256];
  char outputdata[256];
  double cc;

  if (argc != 1 && argc != 4) {
    printf("Usage : changeToUtmV2 inputfilename outputfilename cc\n");
    exit(1);
  }

  if (argc == 1) {
  printf("filename of inputdataset\n");
  scanf("%s",inputdata);
  printf("filename of outputdataset\n");
  scanf("%s",outputdata);
  printf("center longitude of the zone\n");
  scanf("%lf",&cc);
  }
  else {
    sscanf(argv[1], "%s", inputdata);
    sscanf(argv[2], "%s", outputdata);
    sscanf(argv[3], "%lf", &cc);
  }


  FILE * fp_c;
  FILE * fp_o;

  if((fp_c = fopen(inputdata,"r")) ==NULL){
    printf("cannot open file : %s",inputdata);
    exit(1);
  }
  if((fp_o = fopen(outputdata,"w")) ==NULL){
    printf("cannot open file : %s",outputdata);
    exit(1);
  }

  char buf[256];

  while (fgets(buf, 256, fp_c) != NULL) {
    if (strncmp(buf, "[Data of End Points]", 20) == 0) {
      fprintf(fp_o,"%s", buf);
      break;
    }
    else 
      fprintf(fp_o,"%s",buf);
  }

  int n; 
  double lambda;
  double phi;
  double z;
  int info;
  double ue;
  double un;
  
  while(fgets(buf,256,fp_c) != NULL){

    if(strncmp(buf,"[Number of River Segments]", 26) ==0){

      fprintf(fp_o,"%s",buf);
      break;
    }
    else{
      if((sscanf(buf,"%d %lf %lf %lf %d",
		 &n, &lambda, &phi, &z, &info)) ==5){

	ll2utm(lambda, phi, &ue ,&un, cc);
	fprintf(fp_o,"%d %f %f %f %d\n",
		n, ue, un, z, info);
      }
      else{
	fprintf(fp_o,"%s",buf);
      }
    }
  }

  while(fgets(buf,256,fp_c) !=NULL){
    if(strncmp(buf,"[Data]", 6) ==0){
      fprintf(fp_o,"%s",buf);
      break;
    }
    else fprintf(fp_o,"%s",buf);
  }
  
  int t1, t2, t3, t4, t5 ;
  double w;
  while(fgets(buf,256,fp_c) !=NULL){
    if ((sscanf(buf,"%d %d %d %d %d %lf %lf %lf %lf\n",
	   &t1, &t2, &t3, &t4, &t5, &lambda, &phi, &z, &w)) ==9){
      ll2utm(lambda, phi, &ue, &un, cc);
      fprintf(fp_o,"%d %d %d %d %d %f %f %f %f\n",
	      t1, t2, t3, t4, t5, ue, un, z, w);
    }
    else fprintf(fp_o,"%s",buf);
  }
  
  fclose(fp_o);
  fclose(fp_c);
}
