
//#include <stdio.h>
#include <math.h>

void ll2utm( // $B0^7PEY$r(B UTM $B:BI8$KJQ49$9$k!#(B
             // $B9qEZ?tCM>pJs(B($B9qEZD#7W2h!&D4@06I!"9qEZCOM}1!JP!"(B
             // $BBgB">J0u:~6IH/9T(B), pp. 194--196 $B$r;29M$K$7$?!#(B
  double lambda, // $B7PEY!#C10L$OEY!#(B
  double phi,  // $B0^EY!#C10L$OEY!#(B
  double *ue,   // $BEl@>J}8~$N(B UTM $B:BI8!#C10L$O(B m.
  double *un,   // $BFnKLJ}8~$N(B UTM $B:BI8!#C10L$O(B m.
  double cc // $BBP>]$H$9$k(B UTM $B%>!<%sCf1{;R8a@~(B($B86E@(B)$B$N7PEY!#Nc$($P!"(B
            // UTM $B%>!<%s$NBh(B 53 $BBS$O(B 132 $BEY$+$i(B 138 $BEY$NHO0O$G$"$j!"(B
            // $B$3$N>l9g$O(B cc $B$r(B 135 $B$H$9$k!#(B 
)
{                    
  double pi, lambda0, e2, ed2, a, b, b1, b2, b3, 
    l, t2, gamma2, f, f1, f2, A, B, g, g1, g2; 
                                                  
  pi = 4.0*atan(1.0);                                                  
  e2 = 0.006674372;  /* $BBh0lN%?4N($N#2>h(B */
  ed2 = 0.006719219; /* $BBhFsN%?4N($N#2>h(B */ 
  a = 6377.397155;   /* $BCO5eBJ1_BN$ND9H>7B(B(km) */
  b = 6356.078963;   /* $BCO5eBJ1_BN$NC;H>7B(B(km) */
  lambda0 = cc*pi/180.0;    /* $BC10L$r%i%8%"%s$KJQ49(B */
  lambda = lambda*pi/180.0; /* $BC10L$r%i%8%"%s$KJQ49(B */
  phi = phi*pi/180.0;       /* $BC10L$r%i%8%"%s$KJQ49(B */
  A = a/sqrt(1.-e2*pow(sin(phi), 2));                                      
  b1 = 0.998329312962;                                                 
  b2 = 0.00501415801;                                                  
  b3 = 0.00001049328;                                                  
  B = a*(b1*phi-b2*sin(phi)*cos(phi)
     +b3*(sin(phi)*pow(cos(phi), 3)-pow(sin(phi), 3)*cos(phi)));
  l = lambda-lambda0;                                                      
  t2 = pow(tan(phi), 2);                                                    
  gamma2 = ed2*(pow(cos(phi), 2));                                            
  f1 = 1.0-t2+gamma2;                                                     
  f2 = 5.0-18.0*t2+pow(t2, 2)+14.0*gamma2-58.0*t2*gamma2;
  f = A*l*cos(phi)*(1.0+1.0/6.0*pow(l, 2)*pow(cos(phi), 2)
		    *(f1+1.0/20.0*pow(l, 2)*pow(cos(phi), 2)*f2));
  g1 = 5.0-t2+9.0*gamma2+4.0*pow(gamma2, 2);
  g2 = 61.0-58.0*t2+pow(t2, 2)+270.0*gamma2-330.0*t2*gamma2;
  g = B+0.5*A*pow(l, 2)*sin(phi)*cos(phi)
      *(1.0+1.0/12.0*pow(l, 2)*pow(cos(phi), 2)
      *(g1+1.0/30.0*pow(l, 2)*pow(cos(phi), 2)*g2));
  *ue = (0.9996*f+500.0)*1000.0;
  *un = (0.9996*g)*1000.0;
}

/*
void main(void)
{
  double lambda, phi, ue, un, cc;
  
  printf("$B7PEY$rEYC10L$GF~NO$7$J$5$$!#(B\n");
  scanf("%lf", &lambda);
  printf("$B0^EY$rEYC10L$GF~NO$7$J$5$$!#(B\n");
  scanf("%lf", &phi);
  printf("$BBS$NCf1{$N7PEY$rF~NO$7$F$/$@$5$$!#(B\n");
  scanf("%lf", &cc);

  ll2utm(lambda, phi, &ue, &un, cc);

  printf("x = %f : y = %f \n", ue, un);
}
*/





